unit DemoUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  KDaoDataBase, StdCtrls, Grids;

type
  TForm1 = class(TForm)
    KADaoDatabase1: TKADaoDatabase;
    Button1: TButton;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses DAOApi;
{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
Var
 DAOTable  : OleVariant;
 TableName : String;
 TableType : Integer;
 Options   : Integer;
 LockType  : Integer;
 X         : Integer;
 NumFields : Integer;
 Data      : OleVariant;
 CurrentRow: Integer;
begin
  StringGrid1.FixedColor:=clGreen;
  KADaoDatabase1.Open;
  TableName:='bnb-1999';
  TableType:= dbOpenTable;
  Options  := dbInconsistent;
  LockType := dbOptimistic;
  With KADaoDatabase1 do
     Begin
       DAOTable:=CoreDatabase.OpenRecordset(TableName,TableType,Options,LockType);
       NumFields := DAOTable.Fields.Count;
       StringGrid1.ColCount := NumFields;
       StringGrid1.RowCount := DAOTable.RecordCount+1;
       For X := 0 To NumFields-1 do StringGrid1.Rows[0].Add(DAOTable.Fields.Item[X].Name);
       CurrentRow := 1;
       DAOTable.MoveFirst;
       While Not DAOTable.EOF do
         Begin
           For X := 0 To NumFields-1 do
              Begin
                Data := DAOTable.Fields.Item[X].Value;
                if Not VarIsNull(Data) Then
                   StringGrid1.Rows[CurrentRow].Add(Data)
                Else
                   StringGrid1.Rows[CurrentRow].Add('');
              End;
          Inc(CurrentRow);
          DAOTable.MoveNext;
         End;
       DAOTable.Close;
     End;
  KADaoDatabase1.Close;
end;

end.
